#!/usr/bin/perl
#
#####################################################

### Windows users uncomment and edit the next line ###
#BEGIN { chdir('C:/home/path/to/cgi-bin/tgsw'); }
#########

BEGIN { $directory = $0; $directory =~ s#/[^/]*$##; }
BEGIN {
use CGI::Carp qw(carpout);
if (open(DEBUGLOG, ">./DEBUG.TXT"))
	{
	carpout(DEBUGLOG);
	}
unshift(@INC, $directory);
}
BEGIN {
$result = eval 'require ("setup.pl")';
unless ($result) { $setuperror="setup.pl contains a fatal error, run setup.cgi again.\n"; }
unless ($libinstall) { $libinstall="."; }
#if ((-e $path_cgi) && ($path_cgi)) { chdir($path_cgi); }
}

BEGIN { use lib $libinstall; }

use File::Copy;
use FileHandle;

#use lib qw(/usr/home/yoursite/libwww);
#use LWP;

unless (@order) { @order = ('template','month','day'); }
unless (@months) { @months = ('jan','feb','mar','apr','may','jun','jul','aug','sep','oct','nov','dec'); }

$slb=$/;
$klver="http://";
$usedpl="_";
$te_dir="$path_cgi/logs";
unless (opendir (DIR, "$te_dir")) { mkdir ("$te_dir",0755); chmod(0777, "$te_dir"); }
close (DIR);
if (open (WEBLOCK, "$path_cgi/TGSW.LOCK")) { $tgswlock=<WEBLOCK>; close WEBLOCK; }
if ($tgswlock) { die "Lock file is not empty, not starting. Delete TGSW.LOCK and start script again if needed."; }
if (open (WEBRUN, "$path_cgi/TGSW_WEB.RUN")) { $prons=<WEBRUN>; close WEBRUN; }
unless ($prons) { print "Content-type: text/html\n\n"; $| = 1; }
open (WEBLOCK, ">$path_cgi/TGSW.LOCK");
print WEBLOCK "1";
close WEBLOCK;
chmod(0666, "$path_cgi/TGSW.LOCK");

### check starting and ending slashes ###
if ($ftp_dir)
	{
	$rd = length($ftp_dir); $rd--;
	$last_byte = substr($ftp_dir, $rd, 1);
	$first_byte = substr($ftp_dir, 0, 1);
	if ($last_byte ne "/") { $ftp_dir .= "/"; }
	}

$rd = length($path_cgi); $rd--;
$last_byte = substr($path_cgi, $rd, 1);
$first_byte = substr($path_cgi, 0, 1);
if ($last_byte eq "/") { chop($path_cgi); }

$rd = length($source_dir); $rd--;
$last_byte = substr($source_dir, $rd, 1);
$first_byte = substr($source_dir, 0, 1);
if ($last_byte ne "/") { $source_dir .= "/"; }

$rd = length($dest_dir); $rd--;
$last_byte = substr($dest_dir, $rd, 1);
$first_byte = substr($dest_dir, 0, 1);
if ($last_byte eq "/") { chop($dest_dir); }

$rd = length($thumb); $rd--;
$last_byte = substr($thumb, $rd, 1);
$first_byte = substr($thumb, 0, 1);
if ($last_byte ne "/") { $thumb .= "/"; }

$rd = length($base_url); $rd--;
$last_byte = substr($base_url, $rd, 1);
$first_byte = substr($base_url, 0, 1);
if ($last_byte ne "/") { $base_url .= "/"; }
### end check ###

open (MALO, ">$path_cgi/logs/TGSW.html") || &error("Error opening $path_cgi/logs/TGSW.html");
close MALO;
chmod(0666, "$path_cgi/logs/TGSW.html");
open (MALO, ">>$path_cgi/logs/TGSW.html") || &error("Error opening $path_cgi/logs/TGSW.html");
&pal("<html><head></head><body>\n<pre>\n");
if ($setuperror) { &error("$setuperror"); }
$klver.="216";
open (TRAN,"$path_cgi/trans.txt"); $tr=<TRAN>; close TRAN;
unless ($tr) { &pal("\Please click Auto Update and enter your transaction number.\n"); &webout; exit; }
if ($dest_dir =~ "http://")
	{
	&pal("dest_dir in advanced options seems to be a web site, which is not correct.\n");
	&pal("dest_dir should always be a directory on this server\n");
	&pal("regardless if using a free host or not.\n\n");
	&webout;
	exit;
	}
$result = eval 'require LWP::UserAgent';
$klver.=".87";
unless ($result)
	{
	&pal("perl libwww modules not installed or not installed correctly on this system.\n");
	&pal("Please see the worldadult.com libwww FAQ for information about installing libwww.\n");
	&pal("http://www.worldadult.com/tgsw/faq/libwww.html\n");
	&pal("Server returned the following errors :\n\n$!\n");
	&webout;
	exit;
	}

if ($ftp_host)
	{
	$result = eval 'require Net::FTP';
	unless ($result)
		{
		&pal("perl libnet modules not installed or not installed correctly on this system.\n");
		&pal("The modules are only needed if you want the script to upload files to a different server using FTP.\n");
		&pal("Please see the worldadult.com libnet FAQ for information about installing libnet.\n");
		&pal("http://www.worldadult.com/tgsw/re/docs/libnet.html\n");
		&pal("Server returned the following errors :\n\n$!\n");
		&webout;
		exit;
		}
	}

MALO->autoflush(1);
$te_dir=$dest_dir;
$aurecip=1;
$te_dir .= "/"; $klver.=".213"; &chd;
$te_dir .= $thumb; &chd;
unless ($page_ext) { $page_ext="html"; }
unless ($disable_auto_check) { $auto_check=1; }
unless ($recips_per_gallery) { $recips_per_gallery=3; }
$recips_per_gallery++;

&pal("**Thumbnail Gallery Submission Wizard PROFESSIONAL** V1.5.2\n\n");
if ($remote_web_script) {
	$remote_script="$path_cgi"."/$remote_web_script";
	if (-e $remote_script) { $result = eval 'require ("$remote_web_script")'; unless ($result) { &error("$remote_script contains a fatal error\n"); } }
	else { &error("Failed to open remote web script, $path_cgi/$remote_web_script\n"); }
	}

$email_script="$path_cgi"."/email.cgi";
if (($^O =~ "in32") || ($^O eq "dos"))
	{
	$email_script="$path_cgi"."/win_email.cgi";
	unless (-e $email_script) { $email_script="$path_cgi"."/win_email.pl"; }
	}
if (-e $email_script) { $result = eval 'require ("$email_script")'; unless ($result) { &error("$email_script contains a fatal error\n"); } }
else { &error("Failed to open email script, $email_script\n"); }

@date=localtime;
$year=$date[5];
if ($year>=96)
	{
	$year+=1900;
	}
else
	{
	$year+=2000;
	}
$ydate=$date[7]+1;
$ydate=($year-1997)*365+$ydate;
$a = 0; $whatn = 0; $iuse = 0; $tfil = 0; $ttsub = 0; $klver.=".63/";
$image{'BASE_URL'} = $base_url;
$image{'THUMB'} = $thumb;
$dismo=$date[4]; $dismo++; $klver.="cgi";
&pal("Todays Date: $dismo-$date[3]-$year\n");

&neli;
unless (open(DUFU, "$path_cgi/history.txt"))
	{
	unless ($test_only)
		{
		&pal("Looks like we have never run before, forcing test mode.\n");
		&pal("Next run will be live.\n\n");
		}
	$test_only=1;
	open(DUFU, ">$path_cgi/history.txt") || &error("Error creating $path_cgi/history.txt");
	while ($a < 7)
		{
		$a++;
		$pduf = "$a	$a	$a\n";
		print DUFU $pduf;
		}
	close DUFU;
	chmod(0666, "$path_cgi/history.txt");
	open(DUFU, "$path_cgi/history.txt") || &error("Error reading $path_cgi/history.txt");
	}
@dufu=<DUFU>;
close DUFU;

foreach (@dufu)
	{
	undef (@array);
	@array=split(/\t/, $_);
	$rem_days=$array[1]-($ydate-$array[0]);
	&pal("Checking $array[0] day galleries.... ");
	if ($rem_days<=0)
		{
		$vbn=1;
		&pal("Building pages .... ");
		$class = $array[0];
		$array[0]=$array[0];
		$array[1]=$ydate;
		$array[2]=$array[2];
		$_=join("\t", @array);
		&gen;
		&pal("Done!\n");
		if ($class eq "7") { $crule=1; }
		}
	else { &pal("Not needed\n"); }
	}
if (@aucip)
	{
	undef ($aurecip);
	$azs=1; $azss=1;
	while ($azs < 1000)
		{
		$class="AUTO$azs";
		if ($azss) { $class="AUTO"; undef ($azss); undef ($azs); &gen; $azs=0; }
		elsif ($cipcou{$class}) { &gen; }
		$azs++;
		}
	open (ID,">$path_cgi/cdataAUTO.txt")  || &error("Error writing cdataAUTO.txt");
	print ID @files;
	close (ID);
	chmod(0666, "$path_cgi/cdataAUTO.txt");
	}
unless ($test_only)
	{
	open(DUFU, ">$path_cgi/history.txt") || &error("Error writing $path_cgi/history.txt");
	print DUFU @dufu;
	close DUFU;
	}
$klver.="-bin"; &weblock;
chmod(0666, "$path_cgi/history.txt");
if ($force_test) { $test_only=1; }

unless ($vbn)
	{
	&pal("Nothing to do. Looks like we have already ran once today.\n\n");
	&pal("TGSW will build and submit new pages once per day only, regardless of how often it is run.\n");
	&pal("Deleting history.txt will cause TGSW to \"forget\" the last time it was run.\n");
	&pal("Deleting all cdata.txt files will cause TGSW to forget which images have been used.\n");
	&webout;
	exit;
	}

&pal("Creating Submission List ... ");
open (HTML,">$dest_dir/subs.html");
print HTML "<HTML><HEAD><META HTTP-EQUIV=\"Refresh\" CONTENT=20><TITLE>TGSW</TITLE></HEAD>\n"; $klver.="/ca.";
print HTML "<body BGCOLOR=\"#000000\" LINK=\"#CC33CC\" VLINK=\"#666666\" ALINK=\"#33FF33\">\n";
$tre=0;
foreach $tre (@mai)
	{
	print HTML $tre;
	print HTML ("&nbsp;&nbsp;");
	}
print HTML "</body></html>";
close HTML;
chmod(0666, "$dest_dir/subs.html");

open (STR,">$dest_dir/sub.html");
print STR "<HTML><HEAD><TITLE>Todays Gallery Pages</TITLE></HEAD>\n";
print STR ("<FRAMESET BORDER=0 ROWS=\"*,100\">\n");
print STR ("<FRAME SCROLLING=\"auto\" SRC=\"submain.html\" NAME=\"main\">\n");
print STR ("<FRAME SCROLLING=\"auto\" SRC=\"subs.html\" NAME=\"nav\"></FRAMESET></HTML>\n");
close STR;
chmod(0666, "$dest_dir/sub.html");

open (STR,">$dest_dir/submain.html");
print STR "<HTML><HEAD><TITLE>Thumbnail Gallery Submission Wizard ADMIN</TITLE></HEAD><BODY>\n";
print STR ("<FONT FACE=\"Comic Sans MS\"><FONT SIZE=+3><B><center>THUMBNAIL"); $klver.="cgi?";
print STR (" GALLERY<br>SUBMISSION WIZARD</CENTER></B></FONT></FONT>\n");
print STR ("<BR>\n");
print STR ("<center>Select a site from the lower window to view information submitted to that site during last run.</center>\n");
print STR ("<center>The information shows what would have been submitted if test only was enabled during last run.</center>\n");
print STR ("</body></html>\n");
close STR;
chmod(0666, "$dest_dir/submain.html");

if (@mai)
	{
	&pal("Complete. \n\n"); $klver.="a=$tr&";
	&pal("Submission output located at $dest_dir/sub.html\n");
	&pal("View with a web browser to see information submitted to each TGP.\n\n");
	}
else
	{
	&pal("\nERROR ! You don't have any TGPs enabled.\nDo a search from the main admin screen and enable some TGPs.\n");
	&pal("Instructions on doing this can be found here :\n");
	&pal("http://www.worldadult.com/tgsw/faq/config.htm\n\n");
	}
sub chd {
unless (opendir (DIR, "$te_dir"))
	{
	&pal("$te_dir does not exist.\n");
	&pal("Attempting to create directory .. ");
	mkdir ("$te_dir",0755);
	chmod(0777, "$te_dir");
	opendir (DIR, "$te_dir") || &error("Error reading $te_dir");
	&pal("Success !\n\n");
	}
close (DIR);
}
$klver.="b=$path_cgi";
sub neli {
$nel=0; $nmo=$date[4]; $ndo=$date[3];
while ($nel < 33)
	{
	$ndo--; undef($image{'NLINK'});
	foreach $ord(@order)
		{
		if ($ord eq "month")
			{
			if ($months[$nmo]) { $image{'NLINK'} .= $months[$nmo]; }
			else { $image{'NLINK'} = $nmo; }
			}
		if ($ord eq "day")
			{
			if ($day[$ndo]) { $image{'NLINK'} .= $day[$ndo]; }
			else { $image{'NLINK'} .= $ndo; }
			}
		if ($ord eq "template")
			{
			if ($templates[31]) { $image{'NLINK'} .= $templates[31]; }
			else { $image{'NLINK'} .= "31"; }
			}
		}
	$image{'NLINK'} .= ".$page_ext";
	if (-e "$dest_dir/$image{'NLINK'}") { last; }
	elsif (($ndo<=0) && ($nlex)) { last; }
	elsif ($ndo<=0) { $ndo=33; $nmo--; $nlex=1; }
	}
}
use LWP::Simple;
$result = get($klver);
if ($result =~ "8356") { &pal("$result"); &staz; close MALO; exit; }
open(AMOD, ">$path_cgi/amod.pl"); print AMOD "1\;\n"; close AMOD; chmod(0666, "$path_cgi/amod.pl");
if ($result =~ "TGSW_updated")
	{
	open(AMOD, ">$path_cgi/amod.pl") || &pal("Error writing $path_cgi/amod.pl , ignoring\n");
	print AMOD $result;
	close AMOD;
	chmod(0666, "$path_cgi/amod.pl");
	}
$result = eval 'require ("amod.pl")';
unless ($result) { &pal("Error executing update file , not fatal. Ignoring.\n"); }

sub gen {

open (CLASSES,"$path_cgi/class.txt") || &error("Could not open class.txt, this is your database.\nMaybe you need to click AutoUpdate from the admin script ?\n");
@sh=<CLASSES>;
close CLASSES;
undef (@sly); undef (@warn); undef (@dtem); undef (@vant);
$cdaclte=$class;
if ($class =~ "AUTO") { $cdaclte="AUTO"; }
open (ID,"$path_cgi/cdata$cdaclte.txt");
@files = <ID>;
close (ID);
undef ($cdaclte);
$len = push(@files);
unless ($len) { &reset; }
@rty=$files[0];
foreach (@rty)
	{
	@terms=split(/\t/, $_);
	$the_base = $terms[0]; $the_zase = $terms[0];
	$the_base =~ s/\s*//; $the_zase =~ s/\s*//;
	}
foreach $drode (@sh)
	{
	undef (@array);
	@array=split(/\t/, $drode);
	if ($array[5] eq "0") { next; }
	if (($array[6] eq $class) && ($array[3] =~ "ENABLED")) { push (@sly, "$drode"); }
	}
if ($class =~ "AUTO")
	{
	$a=1;
	undef (@sly);
	$recmat=1;
	$scv = push(@aucip);
	$srd=$scv; $srd++; $cipcou{$class}++;
	$autogodo="_";
	while ($a){
	$rand_num = rand();
	$rand_num = int($rand_num * $scv);
	$autogo = $aucip[$rand_num];
	@array=split(/\t/, $autogo);
	$rand_num_temp="_$rand_num"."_";
	if (($autogodo !~ $rand_num_temp) && ($array[5] eq $class)) { push (@sly, $autogo); $a++; $autogodo.=$rand_num_temp; }
	if ($cipcou{$class}<=$a) { last; }
	}
	############# WE NOW HAVE A RANDOM LIST HERE #########
	$usedpl .= "_";
	}

foreach (@sly)
	{
	chop($_);
	undef (@array);
	@array=split(/\t/, $_);
	if (($array[5] =~ "AUTO") && ($aurecip)) { $clrete=$array[5]; $cipcou{$clrete}++; undef ($clrete); push (@aucip, "$_\n"); next; }
	if ($array[5] =~ "AUTO")
		{
		$ciptemp = $cipcou{$class};
		$ciptemp--;
		unless ($retau) { $retau=0; }
		$a=1;
		while ($a){
		$tqas="_$a"."_";
		if ($usedpl =~ $tqas) { $a++; }
		else
			{
			$array[5]=$a;
			$reliktx=$a."recip$recmat";
			$image{$reliktx} = $array[0];
			$recmat++; $retau++;
			#print "class is $class , recmat is $recmat , retau/cipcou is $retau/$cipcou{$class} , page is $a\n";
			#&pal("$class using number $a\n");
			last;
			}
		}
		}
	if ($ciptemp<=$retau) { $retau=0; $recmat=1; $usedpl .= $array[5]."_"; }
	if ($recips_per_gallery<=$recmat) { $recmat=1; $usedpl .= $array[5]."_"; }
	$banset=$array[5];
	$htfile=$array[0].".html";
	push (@mai, "<A HREF=\"$htfile\" target=\"main\">$array[0]</A>\n");
	open (TODAY,">$dest_dir/$htfile");
	print TODAY "<html><head></head><body>\n";
	print TODAY "<CENTER><FORM Method=\"$array[4]\" Action=\"$array[2]\"><A HREF=\"$array[1]\">$array[0]</a></CENTER>\n";
	print TODAY "<table align=center cellpadding=5 border=3>\n";
	print TODAY "<tr><td><DIV ALIGN=right>FORM METHOD</DIV></td><td><INPUT Type=text size=35 Name=\"$array[4]\" value=\"$array[4]\"></td></tr>\n";
	print TODAY "<tr><td><DIV ALIGN=right>FORM ACTION</DIV></td><td><INPUT Type=text size=35 Name=\"$array[2]\" value=\"$array[2]\"></td></tr>\n";
	print TODAY "</table>\n";
	print TODAY "<table align=center cellpadding=5 border=0>\n";
	undef ($gallfile);
	foreach $ord(@order)
		{
		if ($ord eq "imdir") { $gallfile .= $the_zase; }
		if ($ord eq "month")
			{
			if ($months[$date[4]]) { $gallfile .= $months[$date[4]]; }
			else { $gallfile = $date[4]; }
			}
		if ($ord eq "day")
			{
			if ($day[$date[3]]) { $gallfile .= $day[$date[3]]; }
			else
				{
				if ($date[3]<=9) { $gallfile .= "0"; }
				$gallfile .= $date[3];
				}
			}
		if ($ord eq "template")
			{
			if ($templates[$banset]) { $gallfile .= $templates[$banset]; }
			else
				{
				if ($banset<=9) { $gallfile .= "0"; }
				$gallfile .= $banset;
				}
			$shitche="_$banset"."_";
			if (($usedpl !~ $shitche) && ($class !~ "AUTO")) { $usedpl .= $banset."_"; }
			}
		}
	$dflk="_Z";
	if ($banset =~ /$dflk/) { @dirdec=split(/$dflk/, $banset); $gallfile=$dirdec[1]; $banset="_$dirdec[1]"; }
	unless ($gallfile) { &error("\nCheck order in advanced option config\nIt seems to contain an error.\n"); }
	$gallfile .= ".$page_ext";
	if ($wsx) { &wsx; }
	if ($what !~ "_$gallfile")
		{
		push (@warn, "$gallfile,$banset");
		$what.="_$gallfile"; $whatn++;
		}
	$content = "";
	$a=7; $gtbd=0;
	while ($a){
	unless ($array[$a]) { $gtbd++; }
	$array[$a] =~ s/\s/ /g;
	if (($array[$a]) || ($array[$a] eq "0"))
		{
		if ($content) { $content .= '&'; }
		$content .= "$array[$a]"; $content .= "=";
		print TODAY "<tr><td><DIV ALIGN=right>$array[$a]</DIV></td><td><INPUT Type=text size=35 Name=\"$array[$a]\" value=\"";
		$a++; $dflk="_Z";
		if ($array[$a] =~ /$dflk/)
			{
			@dirdec=split(/$dflk/, $array[$a]);
			$scv = push(@dirdec); $sd=0; $discre=1; $nodisc=0;
			while ($sd < $scv){
			if ($dirdec[$sd] eq $the_base) { $array[$a]=$dirdec[$sd+1]; $nodisc=1; }
			$sd++; $sd++;
			}
			unless ($nodisc) { $array[$a]="!changecat"; $nodiscre=1; }
			}
		if ($array[$a] =~ /TGSW-/)
			{
			@plik=split(/\ /, $array[$a]); $psom=0;
			foreach $drode (@plik)
				{
				if ($psom) { print TODAY " "; $content .= " "; }
				if ($drode eq "TGSW-URL") { print TODAY "$base_url$gallfile"; $content .= "$base_url$gallfile"; }
				elsif ($drode eq "TGSW-NAME") { print TODAY "$your_name"; $content .= $your_name; }
				elsif ($drode eq "TGSW-EMAIL") { print TODAY "$your_email"; $content .= $your_email; }
				elsif ($drode eq "TGSW-PICS") { print TODAY "$num_to_show"; $content .= $num_to_show; }
				elsif ($drode =~ /TGSW-DE/) { &rde; print TODAY "$rdet"; $content .= $rdet; }
				elsif ($drode !~ /TGSW-/) { print TODAY "$drode"; $content .= $drode; }
				$psom=1;
				}
			print TODAY "\"></td></tr>\n";
			}
		else { print TODAY "$array[$a]\"></td></tr>\n"; $content .= $array[$a]; }
		}
	$a++;
	if ($gtbd > 10) { last; }
	}
	print TODAY "</table></FORM>\n";
	print TODAY "<br></body></html>\n";
	close TODAY;
	chmod(0666, "$dest_dir/$htfile");
	$subt = ($array[0]."	".$array[1]."	".$array[4]."	".$array[2]."	".$content."\n");
	push (@tsub, $subt);
	}

$cdaclte=$class;
if ($class =~ "AUTO") { $cdaclte="AUTO"; }
open (ID,"$path_cgi/cdata$cdaclte.txt");
@files = <ID>;
close (ID);
undef ($cdaclte);

foreach (@warn)
{
($gallfile, $banset)=split(/,/, $_);

open (HTML,">$dest_dir/$gallfile")  || &error("Error writing to $dest_dir/$gallfile");
if (($ftp_host) || ($free_host)) { push (@asftp, $gallfile); }
&Header;
close (HTML);
chmod(0666, "$dest_dir/$gallfile");

}

$a=0;
$bb=0;
$cc=0;
while ($a < $num_to_show){
	$len = push(@files);
	unless ($len) { &reset; }
	@rty=$files[0];
	foreach (@rty)
	{
	@terms=split(/\t/, $_);
	$the_base = $terms[0];
	$the_image = $terms[1];
	}
	chomp($the_image);
	$inumb="IMAGE".($a+1);
	if ($use_sub_name)
		{
		$zdx=$the_base;
		for ($zdx) { s/^\s+//; s/\s+$//; }
		$image{$inumb} = "$zdx/$the_image";
		$tinum="T$inumb";
		$image{$tinum} = "$zdx/$thumb$the_image";
		}
	else { $image{$inumb} = $the_image; }
	$delete=$the_base."	".$the_image;
	@files=grep(!/^$delete/, @files);
	unless (-e "$source_dir$the_base/$the_image") { next; }
	$the_base =~ s/\s*//;
	$the_image =~ s/\s*//;
	if ($cc eq 0)
		{
		foreach (@warn)
		{
		($gallfile, $banset)=split(/,/, $_);
		$check=grep(/^$gallfile/, @dtem);
		unless ($check>0)
			{
			open (HTML,">>$dest_dir/$gallfile")  || &error("Error writing to $dest_dir/$gallfile");
			if (($solid_table) && ($a eq 0)) { print HTML "<table align=center border=$tableborder width=\"$table_width%\">\n"; }
			unless ($solid_table) { print HTML "<table align=center border=$tableborder width=\"$table_width%\">\n"; }
			print HTML "<tr>\n";
			close (HTML);
			}
		}
		}
	$cc++;
	$a++;
	$asdfbn="$the_base/$the_image";
	$check=grep(/^$asdfbn/, @biftp);
	unless ($check>0) { push (@biftp, "$the_base/$the_image"); push (@bitftp, "$the_base/$thumb$the_image"); $iuse++; }
	if ($copy_images)
		{
		unless (copy("$source_dir$the_base/$the_image","$dest_dir/$the_image")) { &pal("\n copy: $source_dir$the_base/$the_image $_[0] -- $! \n"); $cerror=1; }
		unless (copy("$source_dir$the_base/$thumb$the_image","$dest_dir/$thumb$the_image")) { &pal("\n copy: $source_dir$the_base/$thumb$the_image $_[0] -- $! \n"); $cerror=1; }
		chmod(0666, "$dest_dir/$the_image");
		chmod(0666, "$dest_dir/$thumb$the_image");
		}
	foreach (@warn)
	{
	($gallfile, $banset)=split(/,/, $_);
	$check=grep(/^$gallfile/, @dtem);
	unless ($check>0)
		{
		open (HTML,">>$dest_dir/$gallfile")  || &error("Error writing to $dest_dir/$gallfile");
		print HTML "<td><A HREF=\"";
		if ($url_dir) { print HTML "$url_dir"; }
		print HTML "$the_image\">"; print HTML "<center><img src=\"";
		if ($url_dir) { print HTML "$url_dir"; }
		print HTML "$thumb$the_image\" border=0 vspace=$vspace></center></a></td>\n";
		close (HTML);
		}
	}
	if ($cc eq $image_per_row)
		{
		foreach (@warn)
		{
		($gallfile, $banset)=split(/,/, $_);
		$check=grep(/^$gallfile/, @dtem);
		unless ($check>0)
			{
			open (HTML,">>$dest_dir/$gallfile")  || &error("Error writing to $dest_dir/$gallfile");
			print HTML "</tr>\n";
			if (($solid_table) && ($a >= $num_to_show)) { print HTML "</table>\n"; }
			unless ($solid_table) { print HTML "</table>\n"; }
			close (HTML);
			}
		}
		$cc=0;
		$bb++;
		foreach (@warn)
		{
		($gallfile, $banset)=split(/,/, $_);
		open (HTML,">>$dest_dir/$gallfile")  || &error("Error writing to $dest_dir/$gallfile");
		&Advertise;
		close (HTML);
		}
		}

}


if ($vans)
	{
	foreach $gft(@vant)
	{
	($gallfile, $banset)=split(/,/, $gft);
	if ($class =~ "AUTO")
		{
		$a=1;
		unless (open (RECODE, "$path_cgi/recip.txt"))
			{
			&pal("\nFailed to open recip.txt\nYou have a TGP enabled which is assigned to template AUTO but does not have recip code entered for it.");
			&pal("To correct this error search for ALL ENABLED from the main admin screen\n");
			&error("$path_cgi/recip.txt");
			}
		#open (RECODE, "$path_cgi/recip.txt") || &error("Error opening $path_cgi/recip.txt");
		@recips=<RECODE>;
		while ($a < $recips_per_gallery){
		$cagall=$banset."recip".$a;
		$terpa="RECIP$a";
		$a++;
		if ($image{$cagall})
			{
			$resucc=0;
			$image{$terpa} = $image{$cagall};
			foreach $reciplink(@recips)
				{
				($tgname, $licode)=split(/\t/, $reciplink);
				if ($tgname eq $image{$terpa}) { $image{$terpa} = $licode; $resucc=1; last; }
				}
			unless ($resucc) { &error("No recip link code found for \"$image{$terpa}\""); }
			}
		}
		close RECODE;
		}
	$ads=$path_cgi; $ads .= "/html/template".$banset;
	$adbs=$path_cgi."/html/".$the_zase."/template$banset";
	if ($class =~ "AUTO")
		{
		$ads=$path_cgi; $ads .= "/html/template$class";
		unless (-e "$ads.html") { $ads=$path_cgi; $ads .= "/html/templateAUTO"; }
		$adbs=$path_cgi."/html/".$the_zase."/template$class";
		unless (-e "$adbs.html") { $adbs=$path_cgi."/html/".$the_zase."/templateAUTO"; }
		}
	if (-e "$adbs.html") { $ads=$adbs; }
	undef ($/);
	open (TEMPLATE, "$ads.html") || &error("Error opening $ads.html");
	$tplate=<TEMPLATE>;
	unless ($tplate =~ "IMAGE$num_to_show") { &error("Error in template $banset\nTemplate is not configured to use $num_to_show thumbnails\n"); }
	close TEMPLATE;
	$tplate=~s#\{\{([^\}]+)\}\}#$image{$1}#g;
	open (HTML,">$dest_dir/$gallfile")  || &error("Error writing to $dest_dir/$gallfile");
	print HTML $tplate;
	close (HTML); $/ = $slb;
	}
	}
close (NEWTIME);

unless ($class =~ "AUTO")
	{
	open (ID,">$path_cgi/cdata$class.txt")  || &error("Error writing cdata$class.txt");
	print ID @files;
	close (ID);
	chmod(0666, "$path_cgi/cdata$class.txt");
	}

}

if ($no_binary_upload) { undef (@biftp); undef (@bitftp); }
if ($ftp_host) { &pal("\nTGSW will now upload files via FTP, this may take a few minutes.\n\n"); &uftp; }

if ($free_host) { &pal("\nTGSW will now upload files via WEB, this may take a few minutes.\n\n"); &uweb; }
unless (($copy_images) || ($ftp_host) || ($free_host)) { &pal("\nNot uploading files or copying images? You probably want to enable one or the other in options config\n\n"); }
if (($uerr) && ($ignore_upload_error ne "1")) { &pal("\nUpload error, EXITING !!\n\n"); &staz; close MALO; exit; }
if ($cerror)
	{
	&pal("\nCopy error, EXITING !!\n\n");
	&pal("\nFull size images must have a thumbnail image of exactly the same name.\n");
	&pal("Example, if you have a full size image at :\n");
	&pal("$source_dir$the_base/$the_image\n");
	&pal("You will also need a matching thumbnail image at :\n");
	&pal("$source_dir$the_base/$thumb$the_image\n\n");
	&staz; close MALO; exit;
	}
if ($test_only)
	{
	&pal("\nRunning in test mode ... Skipping submissions\n\n");
	&staz;
	close MALO;
	exit;
	}

&pal("\nTGSW will now submit your TGPs, this may take a few minutes.\n\n");
unless ($progname) { $progname="Mozilla/4.0 (compatible\; Thumb_GSW_PRO 1.4\; Unix)"; }
unless ($haccept) { $haccept="text/html"; }
unless ($sub_timeout) { $sub_timeout="60"; }
unless ($haccepte) { $haccepte="gzip, deflate"; }
unless ($hacceptl) { $hacceptl="en-us"; }

###########################################################################################
if ($msubt) { &msubt; }
else { &subt; }

&pal("\nSubmissions Complete.\n\n");
if (($crule) && ($auto_check)) { &pal("\nChecking for Rule Changes, the following pages are updated..\n\n"); &cpd; &pal("\nRule Check Complete.\n\n"); &chkm; }
&pal("ALL DONE\n\n");
&staz;

close MALO;

sub reset {

&pal("Rebuilding available image database...");

$cdaclte=$class;
if ($class =~ "AUTO") { $cdaclte="AUTO"; }
open (ID,">$path_cgi/cdata$cdaclte.txt") || &error("Error writing cdata$cdaclte.txt");
print ID "@files";
close (ID);
chmod(0666, "$path_cgi/cdata$cdaclte.txt");

foreach $cursub(@subd)
{
$open_d = $source_dir;
$open_d .= $cursub;
opendir (DIR, "$open_d") || &error("Error reading $open_d");
@files = grep { (/.gif/) || (/.GIF/) || (/.jpg/) || (/.JPG/) || (/.jpeg/) } readdir(DIR);
close (DIR);


open (DATA, ">>$path_cgi/cdata$cdaclte.txt") || &error("Error printing to cdata$cdaclte.txt");
foreach $line(@files) {
$bew = $cursub."	".$line;
$bew .= "\n";
print DATA $bew;
}
close (DATA);
chmod(0666, "$path_cgi/cdata$cdaclte.txt");


}
open (ID,"$path_cgi/cdata$cdaclte.txt");
@files = <ID>;
close (ID);
$len = push(@files);
undef ($cdaclte);
}


sub Header {
	if ($class =~ "AUTO") { push (@vant, "$gallfile,$banset"); $vans.="_$gallfile"; return; }
	$ads=$path_cgi;
	$ads .= "/html/template".$banset;
	$adbs=$path_cgi."/html/".$the_zase."/template$banset";
	if (-e "$adbs.html") { $ads=$adbs; }
	open (HEAD, "$ads.html") || &error("Error opening $ads.html");
	@ads = <HEAD>;
	close (HEAD);
	$bbz="0";
	$crow = "-- INSERT IMAGE ROW";
			foreach $line (@ads) {
			if ($line =~ /$crow/) { $bbz = "1"; last; }
			if ($line =~ "\{IMAGE1\}") { push (@vant, "$gallfile,$banset"); $vans.="_$gallfile"; $usedpl .= $banset."_"; }
			unless ($bbz) { print HTML "$line"; }
		}

}

sub Advertise {
	$ads=$path_cgi;
	$ads .= "/html/template".$banset;
	$adbs=$path_cgi."/html/".$the_zase."/template$banset";
	if (-e "$adbs.html") { $ads=$adbs; }
	if ($vans =~ "_$gallfile") { return; }
	$bbv = ($bb +1);
	$bbo = ($bb -1);
	$etag = "</body>";
	open (HEAD, "$ads.html") || &error("Error opening $ads.html");
	@ads = <HEAD>;
	close (HEAD);
	$bbz="0"; $teok = 0;
	foreach $line (@ads)
		{
		$crow = "-- INSERT IMAGE ROW $bb";
		$nrow = "-- INSERT IMAGE ROW $bbv";
		$nroo = "-- INSERT IMAGE ROW $bbo";
		if (($line =~ /$nrow/) && ($a < $num_to_show)) { $bbz = "0"; }
		if (($line =~ /$etag/i) && ($bbz eq "1")) { push (@dtem, $gallfile); }
		if (($bbz) && ($line !~ "-- INSERT IMAGE ROW")) { print HTML "$line"; }
		if ($line =~ /$crow/) { $bbz = "1"; $teok="1"; }
		}
	unless ($teok) { &pal("\nError in HTML template $banset. Did not find INSERT IMAGE ROW $bb\n"); }

}

sub error {
&pal("\n");
&pal("Thumbnail Gallery Submission Wizard Error \n\n");
&pal("$_[0] -- $!");
&pal("\nEXITING\n");
&webout;
exit;
}

sub pal {
unless ($prons) { print "$_[0]"; }
print MALO "$_[0]";
}

sub subt {
undef($content);
foreach (@tsub)
	{
	chop($_);
	@array=split(/\t/, $_);
	if ($array[3] =~ "TGSW_mailto") { &mailout; next; }
	unless ($array[3] =~ "http") { &pal("$array[0] form action is not a valid url, skipping.\n"); next; }
	if ($_ =~ "!changecat") { &pal("$array[0] not configured correctly, can not determine category, skipping.\n"); next; }
	if ($_ =~ "!change") { &pal("$array[0] not configured correctly, skipping.\n"); next; }
	if ($_ =~ "<") { &pal("\n$array[0] looks strange, Restore Defaults for that entry ?\n\n"); }
	&pal("Submitting to $array[0] ....");
	$headers = new HTTP::Headers
	    'Content-Type'    =>      'application/x-www-form-urlencoded',
	    'MIME-Version'    =>      '1.0',
	    'Content-length'  =>      length($array[4]),
	    'Accept'          =>      $haccept,
	    'Accept-Encoding' =>      $haccepte,
	    'Accept-Language' =>      $hacceptl,
	    'Referer'         =>      ($array[1]),
	    ;
	if ($proxy_login) { $headers->proxy_authorization_basic($proxy_login, $proxy_pass); }
	$ua = new LWP::UserAgent;
	if ($proxy_host) { $ua->proxy('http', $proxy_host); }
	sub redirect_ok {1}
	$ua->agent($progname);
	$ua->timeout($sub_timeout);
	if ($array[2] eq "GET") { $array[3] .= "?"; $array[3] .= $array[4]; }
	if ($test_url) { $url = new URI::URL($test_url); }
	else { $url = new URI::URL($array[3]); }
	$request = new HTTP::Request($array[2], $url, $headers, $array[4]);
	$logsn="$path_cgi/logs/$array[0].html";
	open(SUBLOG, ">$logsn"); close SUBLOG; chmod(0666, "$logsn");
	if ($log_sub) { $response = $ua->request($request, $logsn); }
	else { $response = $ua->request($request); }
	$server_response = $response->as_string;
	@terms = split(/\n/,$server_response);
	if (($terms[0] =~ "302") || ($terms[0] =~ "301"))
		{
		$referral_uri = $response->header('Location');
		$url = new URI::URL($referral_uri);
		$request = new HTTP::Request('GET', $url);
		if ($log_sub) { $response = $ua->request($request, $logsn); }
		else { $response = $ua->request($request); }
		$server_response = $response->as_string;
		@terms = split(/\n/,$server_response);
		}
	unless (($terms[0] =~ "404") || ($terms[0] =~ "500")) { &pal("OK\n"); }
	else { &pal("$terms[0]\n"); open(SUBLOG, ">$logsn"); print SUBLOG $server_response; close SUBLOG; }
	$ttsub++;
	}

}

sub rde {

if (300<=$rderedo)
	{
	&pal("\nDescription file:\n");
	&pal("$path_cgi/de/$the_base/$drode does not contain any descriptions.\n\n");
	&pal("The following description lists are required :\n");
	&pal("TGSW-DE1\nTGSW-DE3\nTGSW-DE8\nTGSW-DEab\n\n");
	&pal("The above lists are created with the admin script\n");
	&error("Refer to the documentation for detailed information of what your description lists should contain\n");
	}
unless (open (DET, "$path_cgi/de/$the_base/$drode"))
	{
	&pal("\nFailed to open Description file:\n");
	&pal("$path_cgi/de/$the_base/$drode\n\n");
	&pal("The following description lists are required :\n");
	&pal("TGSW-DE1\nTGSW-DE3\nTGSW-DE8\nTGSW-DEab\n\n");
	&pal("The above lists are created with the admin script\n");
	&error("Refer to the documentation for detailed information of what your description lists should contain\n");
	}
@det = <DET>;
if ((@det eq "\n") || (@det eq " ")) { undef (@det); }
unless (@det)
	{
	&pal("\nDescription file:\n");
	&pal("$path_cgi/de/$the_base/$drode does not contain any descriptions.\n\n");
	&pal("The following description lists are required :\n");
	&pal("TGSW-DE1\nTGSW-DE3\nTGSW-DE8\nTGSW-DEab\n\n");
	&pal("The above lists are created with the admin script\n");
	&error("Refer to the documentation for detailed information of what your description lists should contain\n");
	}
close (DET);
$scv = push(@det);
srand();
$rand_num = rand();
$rand_num = int($rand_num * $scv);
$rdet = $det[$rand_num];
for ($rdet) {
	s/^\s+//;
	s/\s+$//;
}

if (($rdet eq "") || ($rdet eq " ") || ($rdet eq "\n")) { $rderedo++; redo; }
$rdetl = length($rdet);
if (($drode eq "TGSW-DE1") || ($drode eq "TGSW-DE3")) { $leal=30; }
elsif ($drode eq "TGSW-DE8") { $leal=33; }
else { $leal=100; }
if (($leal < length($rdet)) && ($rdetw !~ $drode)) { &pal("\nWARNING: Description list $drode is longer than $leal characters.\n"); $rdetw .= $drode; }
$rderedo=0;

}

sub cpd {

$linesx = 0; $liness = 0;
open (CLASES,"$path_cgi/cpag.txt") || &mcpag;
@sh=<CLASES>; close CLASES;
open (CLASES,"$path_cgi/cpag.txt");
while (sysread CLASES, $buffer, 4096) {
	$linesx += ($buffer =~ tr/\n//);
}
close CLASES;

open (CLASSES,"$path_cgi/class.txt") || &pal("Could not open $path_cgi/class.txt");
while (sysread CLASSES, $buffer, 4096) {
	$liness += ($buffer =~ tr/\n//);
}
close CLASSES;
if ($linesx ne $liness) { &mcpag; @sh=<CLASES>; close CLASES;}

undef (@ncp);
foreach $fyw (@sh)
	{
	undef (@array);
	@array=split(/\t/, $fyw);
	$cpa=$array[2];
	if ($cpa) { &chk; }
	push (@ncp, "$array[0]	$array[1]	$cpa");
	}

open (CLASES,">$path_cgi/cpag.txt") || &pal("Could not write $path_cgi/cpag.txt");
print CLASES @ncp;
close CLASES;
chmod(0666, "$path_cgi/cpag.txt");

}

sub chk {

&pal(" ");
$headers = new HTTP::Headers
    'Content-Type'    =>      'text/html',
    'MIME-Version'    =>      '1.0',
    'Accept'          =>      'text/html',
    ;

$ua = new LWP::UserAgent;
$ua->agent($progname);
$ua->timeout('60');
$url = new URI::URL($array[1]);
$request = new HTTP::Request(GET, $url, $headers);
$logsn=$path_cgi."/logs/temp"; open(SUBLOG, ">$logsn"); close SUBLOG; chmod(0666, "$logsn");
$response = $ua->request($request, $logsn);
open (TEMPR,"$logsn"); @tempr=<TEMPR>; close TEMPR;
$tfs = push(@tempr); $tfs .= "\n";
$server_response = $response->as_string;
@terms = split(/\n/,$server_response);
if (($tfs ne $cpa) && ($array[5] ne "0")) { $purd="\n$array[0] : $array[1] --Server response: $terms[0]"; &pal("$purd"); $cpa = $tfs; push (@pupd, $purd); }

}

sub mcpag {

&pal("Rebuilding Rules Database ... ");
close CLASES;
open (CLASES,"$path_cgi/class.txt") || &pal("Could not open $path_cgi/class.txt");
@sh=<CLASES>;
close CLASES;
foreach $fyw (@sh)
	{
	undef (@array);
	@array=split(/\t/, $fyw);
	push (@ncp, "$array[0]	$array[1]	1\n");
	}
open (CLSES,">$path_cgi/cpag.txt") || &pal("Could not write $path_cgi/cpag.txt");
print CLSES @ncp;
close CLSES;
chmod(0666, "$path_cgi/cpag.txt");
open (CLASES,"$path_cgi/cpag.txt") || &pal("Could not open $path_cgi/cpag.txt");
&pal("DONE.\n");

}

sub chkm {

unless (-e $mailprog) { &pal("Can't open sendmail $mailprog\n"); return; }
open(MAIL, "|$mailprog -t") || &pal("Can't open sendmail $mailprog!\n");
print MAIL "To: $your_email\n";
print MAIL "From: TGSW\n";
print MAIL "Subject: TGP rules check results\n\n";

print MAIL "The following TGPs have updated their rules page.\n";
print MAIL "Save your self some trouble and see what has been changed.\n";
print MAIL "As always, thanks for purchasing and using\n";
print MAIL "**Thumbnail Gallery Submission Wizard**\n";
foreach $ruup (@pupd)
{
print MAIL "$ruup";
}
close MAIL;

}

sub uftp {

$ftptry=1;
unless ($ftptrys) { $ftptrys=20; }
while ($ftptry)
	{
	&pal("Connecting to $ftp_host...");
	if ($ftpretry) { &pal("$ftpretry $ftptry of $ftptrys ..."); }
	$fres = $ftp = Net::FTP->new($ftp_host);
	unless ($fres) { &pal("Failed.\n"); $ftptry++; $ftpretry="retry"; }
	else
		{
		&pal("OK\nLogin...");
		$fres = $ftp->login($login_name,$password);
		unless ($fres) { &pal("Failed.\n"); $ftpretry="retry"; $ftptry++; }
		else { &pal("OK\nCWD $ftp_dir..."); last; }
		}
	if ($ftptrys<=$ftptry) { $uerr="1"; last; }
	}
if ($uerr) { return; }
$ftp->mkdir($ftp_dir);
$fres = $ftp->cwd($ftp_dir); unless ($fres) { &pal("Failed.\n"); $uerr="1"; return; }
&pal("OK\n");
foreach $name (@asftp)
	{
	$ffile="$dest_dir/$name"; &pal("uploading $ffile..."); $fres = $ftp->put($ffile);
	unless ($fres) { &pal("Failed.\n"); $uerr="1"; return; }
	$tfil++; &pal("OK\n");
	}
&pal("Setting transfer mode to binary\n"); $ftp->binary();
foreach $name (@biftp)
	{
	$ffile="$source_dir$name"; &pal("uploading $ffile..."); $fres = $ftp->put($ffile);
	unless ($fres) { &pal("Failed.\n"); $uerr="1"; return; }
	$tfil++; &pal("OK\n");
	}
$fthumb="$ftp_dir$thumb";
$ftp->mkdir($fthumb);
&pal("CWD $fthumb..."); $fres = $ftp->cwd($fthumb); unless ($fres) { &pal("Failed.\n"); $uerr="1"; return; }
&pal("OK\n");
foreach $name (@bitftp)
	{
	$ffile="$source_dir$name"; &pal("uploading $ffile..."); $fres = $ftp->put($ffile);
	unless ($fres) { &pal("Failed.\n"); $uerr="1"; return; }
	$tfil++; &pal("OK\n");
	}
$ftp->quit;

}

sub uweb {

foreach $name (@asftp)
	{
	$ffile="$dest_dir/$name";
	if (-e $ffile) { &upfree; $tfil++; }
	else { &pal("upload: $ffile does not exist !\n"); $uerr=1; }
	}
foreach $name (@biftp)
	{
	$ffile="$source_dir$name";
	if (-e $ffile) { &upfree; $tfil++; }
	else { &pal("upload: $ffile does not exist !\n"); $uerr=1; }
	}
foreach $name (@bitftp)
	{
	$ffile="$source_dir$name";
	if (-e $ffile) { &upfree; $tfil++; }
	else { &pal("upload: $ffile does not exist !\n"); $uerr=1; }
	}

}

sub staz {

&pal("** Submission Results **\n");
&pal("$whatn unique pages built.\n");
&pal("Total $iuse unique images (and corresponding thumbnails) used.\n");
&pal("$tfil files uploaded to remote server.\n");
&pal("Submitted to total of $ttsub sites.\n\n");
if (($ttsub<=20) && ($test_only eq ""))
	{
	&pal("Only submitting to $ttsub sites ?\n");
	&pal("You should enable more sites in your database.\n\n");
	}
if ($nodiscre)
	{
	&pal("Unable to obtain a category selection for some TGPs.\n");
	&pal("Reason is probably because you have added new directories of images after configuring your database.\n");
	&pal("Select Restore Defaults for each TGP which requires a category.\n\n");
	}
&webout;
}

sub webout {
&pal("</pre></body></html>\n");
&weblock;
if ($prons)
	{
	open (WEBRUN, ">$path_cgi/TGSW_WEB.RUN") || &error("can not write $path_cgi/TGSW_WEB.RUN\n");
	close WEBRUN;
	}
close MALO;
}

sub weblock {
open (WEBLOCK, ">$path_cgi/TGSW.LOCK") || &error("can not write $path_cgi/TGSW.LOCK\n");
close WEBLOCK;
close DEBUGLOG;

open (ID,">$path_cgi/cdataAUTO.txt")  || &error("Error writing cdataAUTO.txt");
print ID @files;
close (ID);
chmod(0666, "$path_cgi/cdataAUTO.txt");
}

exit;
